<template>
  <div class="module module-slider-personen">
    <div class="row position-relative">
      <transition name="fade">
        <div
          v-if="kontaktpersonen"
          key="slider"
          class="col-12 col-md-10 offset-md-1"
        >
          <atom-slider
            ref="flickity"
            class="main-carousel flickity"
            :options="flickityOptions"
            :auto-init="false"
          >
            <div
              v-for="(kontaktperson, index) in kontaktpersonen.nodes"
              :key="index"
              class="slide"
            >
              <atom-contact-card :data="kontaktperson" />
            </div>
          </atom-slider>
          <div class="flickity-mobile-controls">
            <button
              v-if="isMobile"
              class="flickity-button flickity-prev-next-button previous"
              type="button" aria-label="Previous"
              @click="$refs.flickity.previous()"
            >
              <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 48 23" style="enable-background:new 0 0 48 23" xml:space="preserve">
                <path d="m35.6 0-2 2 8.3 8.3H-1v2.8h42.5L33.6 21l2 2L47 11.5z"/>
              </svg>
            </button>
            <ol class="flickity-page-dots">
              <li
                v-for="(slide, index) in kontaktpersonen.nodes"
                :key="index"
                class="dot"
                :class="{ 'is-selected': selectedSlide === index }"
                @click="$refs.flickity.select(index)"
              ></li>
            </ol>
            <button
              v-if="isMobile"
              class="flickity-button flickity-prev-next-button next"
              type="button" aria-label="Next"
              @click="$refs.flickity.next()"
            >
              <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 48 23" style="enable-background:new 0 0 48 23" xml:space="preserve">
                <path d="m35.6 0-2 2 8.3 8.3H-1v2.8h42.5L33.6 21l2 2L47 11.5z"/>
              </svg>
            </button>
          </div>
          <button
            v-if="isDesktop"
            class="flickity-button flickity-prev-next-button flickity-prev-next-button-desktop previous"
            type="button" aria-label="Previous"
            @click="$refs.flickity.previous()"
          >
            <svg class="flickity-button-icon" viewBox="0 0 100 100">
              <path d="M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z" class="arrow"></path>
            </svg>
          </button>
          <button
            v-if="isDesktop"
            class="flickity-button flickity-prev-next-button flickity-prev-next-button-desktop next"
            type="button" aria-label="Next"
            @click="$refs.flickity.next()"
          >
            <svg class="flickity-button-icon" viewBox="0 0 100 100">
              <path d="M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z" class="arrow" transform="translate(100, 100) rotate(180) "></path>
            </svg>
          </button>
        </div>
        <div v-else key="spinner" class="loader">
          <div class="logo-group">
            <div class="hole"></div>
            <div class="knob"></div>
          </div>
        </div>
      </transition>
    </div>
  </div>
</template>

<script>
import allKontaktpersonen from "~/apollo/queries/allKontaktpersonen";

export default {
  data() {
    return {
      kontaktpersonen: null,
      selectedSlide: 0,
      flickityOptions: {
          wrapAround: true,
          cellAlign: 'left',
          groupCells: false,
          autoPlay: false,
          selectedAttraction: 0.025,
          friction: 0.3,
          pageDots: false,
          prevNextButtons: false,
          arrowShape: 'M79.6 8.8 70.4 0l-50 50 50 50 9.2-8.8L38.3 50z',
          // any options from Flickity can be used
      },
    };
  },
  computed: {
    isMobile() {
      return this.$mq === 'sm' || this.$mq === 'xs';
    },
    isDesktop() {
      return this.$mq !== 'sm' && this.$mq !== 'xs';
    },
  },
  watch: {
    kontaktpersonen() {
      this.$nextTick(() => {
        if (this.$refs.flickity) {
          this.$refs.flickity.rerender();

          this.$refs.flickity.on('change', (index) => {
            this.selectedSlide = index;
          });
        }
      });
    },
  },
  apollo: {
    kontaktpersonen: {
      query: allKontaktpersonen,
      prefetch: false,
    },
  },
}
</script>

<style lang="scss">
.module-slider-personen {
  @include media-breakpoint-down(sm) {
    padding-bottom: 0;
  }

  .loader {
    padding: 0 0 4rem;
    position: absolute;
    top: 40%;
    left: 50%;
    transform: translate(-50% -50%);
  }

  .logo-group {
    position: relative;
    width: 42px;
    height: 22px;
    animation: 'loading-spin' 2.5s infinite linear;

    .hole {
      border-radius: 25px;
      width: 100%;
      height: 100%;
      border: 3.5px solid $black;
    }

    .knob {
      background: $green;
      width: 24px;
      height: 24px;
      border-radius: 50%;
      position: absolute;
      top: -1px;
      left: -3px;
      animation: 'loading-knob' 2.5s infinite linear;
      background: $red;
    }
  }

  .row {
    min-height: 590px;
  }

  @include media-breakpoint-down(lg) {
    .col-12 {
      padding: 0;
    }
  }

  .slide {
    width: 100%;
    overflow: hidden;

    @include media-breakpoint-up(md) {
      width: calc(50% - 1.5rem);
      max-width: calc(50% - 1.5rem);
      margin-right: 2rem;
    }

    @include media-breakpoint-up(lg) {
      width: 31%;
      max-width: 31%;
      margin-right: 3.5%;
    }

    @include media-breakpoint-up(xl) {
      width: 334px;
      max-width: 33.333%;
      margin-right: calc((100% - 1002px) / 2);
    }
  }

  .flickity-prev-next-button-desktop {
    @include media-breakpoint-up(md) {
      transform: translateY(-50%) translateY(-32px);
    }

    @include media-breakpoint-up(lg) {
      transform: translateY(-50%) translateY(-48px);
    }

    &:hover {
      background: transparent;
    }

    &.previous {
      left: -10.5%;

      @include media-breakpoint-up(md) {
        left: -50px;
      }

      @include media-breakpoint-up(lg) {
        left: -75px;
      }

      @include media-breakpoint-up(xl) {
        left: -100px;
      }
    }

    &.next {
      right: -10.5%;

      @include media-breakpoint-up(md) {
        right: -50px;
      }

      @include media-breakpoint-up(lg) {
        right: -75px;
      }

      @include media-breakpoint-up(xl) {
        right: -100px;
      }
    }
  }

  .flickity-mobile-controls {
    display: flex;

    @include media-breakpoint-up(md) {
      padding-top: 1rem;
      padding-bottom: 0;
    }

    .flickity-page-dots {
      display: block;
    }
  }
}
</style>
